<?php
/* Word generator

Generates words based on specified words

PARAMETERS:
$aWords: words to use for generating

RETURNS:
ARRAY: words that will be created for generating passwords
*/
function CreateWords($aWords){
	// first three chars of each word
	$aFirstThreeChars = array();
	$aFirstThreeCharsLC = array();
	$aFirstThreeCharsUC = array();
	$aFirstThreeCharsNH = array();
	$aFirstThreeCharsNU = array();
	// full words
	$aFullWords = array();
	for($x=0;$x<count($aWords);$x++){
		if(strlen($aWords[$x])>2){
			$sWord = trim($aWords[$x]);
			$sWordTrim = substr($sWord,0,3);
			$iWord = strlen($sWord);
			if($iWord<3 || strlen($sWordTrim)<3){
				continue;
			}
			$aFirstThreeChars[] = $sWordTrim;
			$aFirstThreeCharsLC[] = strtolower($sWordTrim);
			$aFirstThreeCharsUC[] = strtoupper($sWordTrim);
			$aFirstThreeCharsNH[] = str_replace("-","",$sWordTrim);
			$aFirstThreeCharsNU[] = str_replace("_","",$sWordTrim);
			if($iWord>3){
				$sFour = substr($sWord,0,4);
				$sFourR = strrev($sFour);
				$aFullWords[] = $sFour;
				$aFullWords[] = $sFourR;
				if($iWord>4){
					$sFive = substr($sWord,0,5);
					$sFiveR = strrev($sFive);
					$aFullWords[] = $sFive;
					$aFullWords[] = $sFiveR;
				}
			}
			$aFullWords[] = $sWord;
			$aFullWords[] = strrev($sWord);
			$aFullWords[] = ucfirst($sWord);
			$aFullWords[] = strtoupper($sWord);
			$aFullWords[] = strtolower($sWord);
			$aFullWords[] = str_replace("-","",$sWord);
			$aFullWords[] = str_replace(" ","",$sWord);
			$aFullWords[] = str_replace("_","",$sWord);
		}
	}
	$aFullWords2 = array_keys(array_flip($aFullWords));
	$aFirstThreeChars = array_unique(array_merge($aFirstThreeChars,$aFirstThreeCharsLC,$aFirstThreeCharsUC,$aFirstThreeCharsNH,$aFirstThreeCharsNU));
	// first three chars of each word reverse
	$aFirstThreeCharsRev = array();
	for($x=0;$x<count($aFirstThreeChars);$x++){
		$aFirstThreeCharsRev[] = @strrev($aFirstThreeChars[$x]);
	}
	return(array_unique(array_merge($aFirstThreeChars,$aFirstThreeCharsRev,$aFullWords2)));
}

/* Password generator

Generates passwords based on specified words

PARAMETERS:
$aWords: words to use for generating
$aCommon: common words from common.php

RETURNS:
VOID: data is globally used
*/

function CreatePasses($aWords,$aCommon){
	global $sBuffer;
	$aWords = array_values($aWords);
	$iWords = count($aWords);
	$iCommon = count($aCommon);
	for($x=0;$x<$iWords;$x++){
		$sWord = @trim($aWords[$x]);
		if($sWord!=""){
			$sBuffer .= $sWord."\n";
		}
	}
	$aData = array();
	$aData[0] = array("iCommon","iCommon","iCommon");
	$aData[1] = array("iCommon","iCommon","iWords");
	$aData[2] = array("iCommon","iWords","iCommon");
	$aData[3] = array("iCommon","iWords","iWords");
	$aData[4] = array("iWords","iWords","iWords");
	$aData[5] = array("iWords","iCommon","iWords");
	$aData[6] = array("iWords","iWords","iCommon");
	$aData[7] = array("iCommon","iCommon");
	$aData[8] = array("iCommon","iWords");
	$aData[9] = array("iWords","iWords");
	$aData[10] = array("iWords","iCommon");
	// combinations
	foreach($aData as $iKey=>$aValues){
		// word 1
		$sTempRoot = "";
		for($x=0;$x<${$aData[$iKey][0]};$x++){
			// FLAGD: empty buffer and write
			$sTempRoot = @${str_replace("i","a",$aData[$iKey][0])}[$x];
			if(isset($aData[$iKey][1])){
				// word 2
				for($y=0;$y<${$aData[$iKey][1]};$y++){
					$sTempSub1 = "";
					if(!isset($aData[$iKey][2])){
						$sBuffer .= $sTempRoot.${str_replace("i","a",$aData[$iKey][1])}[$y]."\n";
					}
					else{
						$sTempSub1 = ${str_replace("i","a",$aData[$iKey][1])}[$y];
					}
					if(isset($aData[$iKey][2])){
						// word 3
						for($z=0;$z<${$aData[$iKey][2]};$z++){
							$sBuffer .= $sTempRoot.$sTempSub1.${str_replace("i","a",$aData[$iKey][2])}[$z]."\n";
						}
					}
				}
			}
		}
	}
	$sBuffer = str_replace("\n\n","\n",$sBuffer);
	//$sBuffer = preg_replace('/(\r?\n){2,}/',"\n",$sBuffer);
}
?>