<?php
/* Load the environment, sets the missing default paths and variable values */

// ok let's make sure the scripts can't be accessed directly
define('IN_SCRIPT',1);
if(!defined('SCREEN')){
	// if the script isn't included on index.php, but from a stand-alone app like the screen.php iframe output files 
	@include("paths.php");
}
if(!isset($_PATHS['root'])){
	// if we can't load paths no need to bother doing anything anymore
	die((!@file_exists("paths.php") ? "Failed to load <b>paths.php</b>" : "Unexpected data in <b>paths.php</b>"));
}
// need the context variables also, just to keep track of the user's current action
if(!file_exists($_PATHS['root']."/vars.php") ? die("Root path in <b>paths.php</b> is invalid") : include($_PATHS['root']."/vars.php"));
// insert authentication
include($_PATHS['root']."/auth.php");
// set hacksuite version
include($_PATHS['data_root']."/version.php");
// style variable, if setup fails load the default style
include($_PATHS['data_root']."/style.php");
if(isset($_STYLE) && strlen($_STYLE)>0){
	// is the location ok, let's do a test..
	if(file_exists($_PATHS['root']."/Templates/".$_STYLE."/index.php")){
		// setup the correct location of template files
		$_PATHS['style_root'] = $_PATHS['root']."/Templates/".$_STYLE;
		// user defined style, if this stays empty use the default style
		$_PATHS['style_user'] = $_STYLE;
		// the current style http root
		$_PATHS['style_root_http'] = $_PATHS['root_http']."/Templates/".$_STYLE;
	}
	else{
		// setup the correct location of template files
		$_PATHS['style_root'] = $_PATHS['style_default_root'];
		// the current style http root
		$_PATHS['style_root_http'] = $_PATHS['style_default_root_http'];
	}
	$_PATHS['end'] = $_PATHS['style_root']."/error/index.php";
}
// function to get directories from a directory
include_once($_PATHS['functions_root']."/getdirbydir.php");
// function to filter out evil content
include_once($_PATHS['functions_root']."/exploitfilter.php");
// function to see if a file is present
include_once($_PATHS['functions_root']."/isthere.php");
// get and set modules
include_once($_PATHS['includes_root']."/modset.php");
// load the link maps
include($_PATHS['data_root']."/link_map.php");
include($_PATHS['data_root']."/links_thc.php");
// load widgets
include($_PATHS['data_root']."/widgets.php");
// default appearance of widgets and other stuff
include_once($_PATHS['data_root']."/appearance.php");
// if we have a current module let's load it up
if($_CONTEXT['module_current']!="" && !defined('SCREEN')){
	include($_PATHS['module_default_root']."/index.php");
}
// if no module has been specified or any other location the current style's index page will be displayed
?>